#line 1 "C:/Users/Rega/SkyDrive/Projects/Mikro/WiFi Ad-Hoc _V1/Wifi Ad-Hoc Server/Wifi_AdHoc_Server.c"
#line 27 "C:/Users/Rega/SkyDrive/Projects/Mikro/WiFi Ad-Hoc _V1/Wifi Ad-Hoc Server/Wifi_AdHoc_Server.c"
sbit Net_Wireless_MCW1001_Chip_RST at GPIOC_ODR.B3;






char myIpAdd[4] = {169, 254, 0, 10};
char myMacAdd[6] = {0x22, 0x33, 0x44, 0x55, 0x66, 0x88};
char netMask[4] = {255, 255, 0, 0};
char gatewayAdd[4] = {169, 254, 0, 1};
char remoteIpAdd[4];
unsigned int remotePort, localPort;
char strSSID[18] = "WiFi_AdHoc_Server";
char channels[11] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};
char wifiStatus, bindResponse, backLog, listenResponse;
char socketHandle, socketChild;
char response;
unsigned int numOfSendBytes;

unsigned int DS1820_VALUE, LM35_VALUE;
char readbuff[10];
char writebuff[10];




unsigned int wifiTmr = 0;
void TIMER2_interrupt() iv IVT_INT_TIM2{
 TIM2_SR.UIF = 0;
 wifiTmr++;
 if(wifiTmr == 3) {
 Net_Wireless_MCW1001_Time++ ;
 wifiTmr = 0;
 }
}




void InitMcu() {


 RCC_APB1ENR.TIM2EN = 1;
 TIM2_CR1.CEN = 0;
 TIM2_PSC = 366;
 TIM2_ARR = 65514;
 NVIC_IntEnable(IVT_INT_TIM2);
 TIM2_DIER.UIE = 1;
 TIM2_CR1.CEN = 1;


 GPIO_Digital_Output(&GPIOE_BASE, _GPIO_PINMASK_15);
 GPIOE_ODR.B15 = 0;
 ADC1_Init();
 Sound_Init(&GPIOE_ODR, 14);
 Net_Wireless_MCW1001_HwReset();

}




void InitWiFi() {
 volatile char response;

 Net_Wireless_MCW1001_TimeToWait = 1;
 response = 1;
 while(response != 0)
 response = Net_Wireless_MCW1001_SetMode(_NET_WIRELESS_MCW1001_CP_1, _NET_WIRELESS_MCW1001_MODE_ADHOC);

 Net_Wireless_MCW1001_TimeToWait = 10;
 response =Net_Wireless_MCW1001_SetChannelList(1, channels);
 response =Net_Wireless_MCW1001_SetSecurity_Open(_NET_WIRELESS_MCW1001_CP_1);
 response =Net_Wireless_MCW1001_SetSSID(_NET_WIRELESS_MCW1001_CP_1, strSSID);


 Net_Wireless_MCW1001_SetIP(myIpAdd);
 response =Net_Wireless_MCW1001_SetNetworkMask(netMask);
 Net_Wireless_MCW1001_SetGatewayIP(gatewayAdd);
 Net_Wireless_MCW1001_SetMAC(myMacAdd);

 Net_Wireless_MCW1001_SetArpTime(1);
 Net_Wireless_MCW1001_SetRetryCount(5, 0);

}

unsigned int ReadDS1820(){
 unsigned int temp;

 Ow_Reset(&GPIOA_BASE, 3);
 Ow_Write(&GPIOA_BASE, 3, 0xCC);
 Ow_Write(&GPIOA_BASE, 3, 0x44);
 Delay_ms(750);

 Ow_Reset(&GPIOA_BASE, 3);
 Ow_Write(&GPIOA_BASE, 3, 0xCC);
 Ow_Write(&GPIOA_BASE, 3, 0xBE);

 temp = Ow_Read(&GPIOA_BASE, 3);
 temp = (Ow_Read(&GPIOA_BASE, 3) << 8) + temp;
 return temp;
}




char CheckTcpReceive() {
 unsigned int numOfReceiveBytes = 0;
 char result=0;

 response = Net_Wireless_MCW1001_TCP_ReadBytes(&socketChild, 10, &readbuff, &numOfReceiveBytes);

 if((response == _NET_WIRELESS_MCW1001_NO_ERROR) && (numOfReceiveBytes == 10)) {
 GPIOE_ODR.B15 = ~GPIOE_ODR.B15 ;
 result=0xFF;
 }
 return result;
}

void Read(){
 writebuff[0]=0xF;
 writebuff[1]=0xF;

 DS1820_VALUE = ReadDS1820();

 writebuff[2]=(char)((DS1820_VALUE >> 8) & 0xFF);
 writebuff[3]=(char)(DS1820_VALUE & 0xFF);


 LM35_VALUE = ADC1_Read(10);
 delay_ms(10);

 writebuff[4]=(char)((LM35_VALUE >> 8) & 0xFF);
 writebuff[5]=(char)(LM35_VALUE & 0xFF);
}




void main() {

 InitMcu();
 ADC_Set_Input_Channel(_ADC_CHANNEL_10);

 UART2_Init_Advanced(115200, _UART_8_BIT_DATA, _UART_NOPARITY, _UART_TWO_STOPBITS, &_GPIO_MODULE_USART2_PD56);
 Delay_ms(2000);

 InitWiFi();

 Net_Wireless_MCW1001_Connect(_NET_WIRELESS_MCW1001_CP_1, &wifiStatus);
 localPort = 10002;

 while(1) {
 socketHandle = 0;
 backLog = 1;
 Net_Wireless_MCW1001_SocketCreate(&socketHandle, _NET_WIRELESS_MCW1001_SOCKET_TYPE_TCP);
 Net_Wireless_MCW1001_SocketBind(socketHandle, &localPort, &bindResponse);
 Net_Wireless_MCW1001_TCP_Listen(socketHandle, &backLog, &listenResponse);

 while(1) {
 socketChild = socketHandle;
 Net_Wireless_MCW1001_TCP_Accept(&socketChild, &remotePort, remoteIpAdd);
 if (socketChild != 254) {

 GPIOE_ODR.B15 = 1;
 Sound_Play(800, 200);
 Delay_ms(100);
 Sound_Play(800, 200);
 Delay_ms(1000);
 break;
 }
 }


 while(1) {

 if(CheckTcpReceive()){
 if(readbuff[0] == 0xF){
 Read();
 response = Net_Wireless_MCW1001_TCP_SendBytes(socketChild, writebuff, 10, &numOfSendBytes);
 }
 }else{
 if(Net_Wireless_MCW1001_TCP_Status(socketChild, 0x1) != 0) {
 Net_Wireless_MCW1001_SocketClose(socketChild);
 Net_Wireless_MCW1001_SocketClose(socketHandle);
 GPIOE_ODR.B15 = 0;
 Sound_Play(800, 200);
 Delay_ms(100);
 break;
 }


 }



 }

 }
}
